import { ActionCreatorsMapObject } from "redux";
import { ReducerDict, SceneReducer, SceneBundleOptions, SceneBundle } from "../types";
import { CurtainReduxInfo } from "../reducers/types";
export interface ApplyReduxPayload<P, S, A extends ActionCreatorsMapObject, PP> {
    arenaReducerDict: ReducerDict;
    state: S;
    saga: ((...params: any[]) => any) | null | undefined;
    actions: ActionCreatorsMapObject;
    reducer: SceneReducer<S>;
    options: SceneBundleOptions | null | undefined;
}
export declare function sceneApplyRedux<P, S, A extends ActionCreatorsMapObject, PP>({arenaReducerDict, state, saga, actions, reducer, options}: ApplyReduxPayload<P, S, A, PP>): any;
export interface UpdateReduxPayload<P extends PP, S, A extends ActionCreatorsMapObject, PP> extends ApplyReduxPayload<P, S, A, PP> {
    curSceneBundle: SceneBundle<P, S, A, PP>;
    reduxInfo: CurtainReduxInfo<S>;
}
export declare function sceneUpdateRedux<P extends PP, S, A extends ActionCreatorsMapObject, PP>({arenaReducerDict, state, saga, actions, reducer, options, curSceneBundle, reduxInfo}: UpdateReduxPayload<P, S, A, PP>): any;
