import ActionTypes from "../ActionTypes";
import getSceneInitState from "./getSceneInitState";
function sceneReducer(state, action) {
    if (state === void 0) { state = getSceneInitState(); }
    switch (action.type) {
        case ActionTypes.ARENA_SCENE_SET_STATE:
            return Object.assign({}, state, action.state);
        case ActionTypes.ARENA_SCENE_REPLACE_STATE:
            return Object.assign({}, action.state);
        default:
            return state;
    }
}
export default function createSceneReducer(extendSceneReducer, initState, sceneReducerKey) {
    return function (state, action) {
        if (state === void 0) { state = initState; }
        var isSceneAction = action._sceneReducerKey && action._sceneReducerKey === sceneReducerKey
            ? true
            : false;
        if (extendSceneReducer) {
            state = extendSceneReducer(state, action, isSceneAction);
        }
        return isSceneAction ? sceneReducer(state, action) : state;
    };
}
