var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import ActionTypes from "../ActionTypes";
import { takeEvery, take, put, fork, select, cancel, setContext, getContext } from "redux-saga/effects";
import { applySceneBundle } from "./sceneBundleSaga";
function takeEverySceneBundleAction() {
    var _reducerKey, lastTask, action;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, getContext("_reducerKey")];
            case 1:
                _reducerKey = _a.sent();
                _a.label = 2;
            case 2:
                if (!true) return [3 /*break*/, 8];
                return [4 /*yield*/, take(ActionTypes.ARENA_CURTAIN_LOAD_SCENE)];
            case 3:
                action = _a.sent();
                if (!(action.arenaReducerDict._arenaCurtain.reducerKey === _reducerKey)) return [3 /*break*/, 7];
                if (!(lastTask && lastTask.isRunning())) return [3 /*break*/, 5];
                return [4 /*yield*/, cancel(lastTask)];
            case 4:
                _a.sent();
                _a.label = 5;
            case 5: return [4 /*yield*/, fork(applySceneBundle, action)];
            case 6:
                lastTask = _a.sent();
                _a.label = 7;
            case 7: return [3 /*break*/, 2];
            case 8: return [2 /*return*/];
        }
    });
}
/**
 * Listen to the loading of each scene,
 * and handle different processing functions when handling scene switches.
 *
 * @param {any} ctx
 */
function forkSagaWithContext(ctx) {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, setContext(ctx)];
            case 1:
                _a.sent();
                return [4 /*yield*/, fork(takeEverySceneBundleAction)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
function initArenaCurtainSaga(_a) {
    var reducerKey = _a.reducerKey, setSagaTask = _a.setSagaTask;
    var sagaTask;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, fork(forkSagaWithContext, {
                    _reducerKey: reducerKey
                })];
            case 1:
                sagaTask = _b.sent();
                setSagaTask(sagaTask);
                return [2 /*return*/];
        }
    });
}
function killArenaCurtainSaga(_a) {
    var sagaTaskPromise = _a.sagaTaskPromise, reducerKey = _a.reducerKey;
    var sagaTask, store, reduxInfo;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, sagaTaskPromise];
            case 1:
                sagaTask = _b.sent();
                if (!sagaTask) return [3 /*break*/, 3];
                return [4 /*yield*/, cancel(sagaTask)];
            case 2:
                _b.sent();
                _b.label = 3;
            case 3: return [4 /*yield*/, getContext("store")];
            case 4:
                store = _b.sent();
                return [4 /*yield*/, put({
                        type: ActionTypes.ARENA_STATETREE_NODE_DISABLE,
                        reducerKey: reducerKey
                    })];
            case 5:
                _b.sent();
                return [4 /*yield*/, select(function (state) { return state[reducerKey]; })];
            case 6:
                reduxInfo = (_b.sent()).reduxInfo;
                if (!(reduxInfo && reduxInfo.reducerKey != null)) return [3 /*break*/, 8];
                return [4 /*yield*/, put({
                        type: ActionTypes.ARENA_STATETREE_NODE_DELETE,
                        reducerKey: reduxInfo.reducerKey
                    })];
            case 7:
                _b.sent();
                store.removeSingleReducer(reduxInfo.reducerKey);
                _b.label = 8;
            case 8:
                store.removeSingleReducer(reducerKey);
                return [2 /*return*/];
        }
    });
}
export default function saga() {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, takeEvery(ActionTypes.ARENA_CURTAIN_INIT_SAGA, initArenaCurtainSaga)];
            case 1:
                _a.sent();
                return [4 /*yield*/, takeEvery(ActionTypes.ARENA_CURTAIN_CLEAR_REDUX, killArenaCurtainSaga)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
