var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import * as PropTypes from "prop-types";
var BundleComponent = /** @class */ (function (_super) {
    __extends(BundleComponent, _super);
    function BundleComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BundleComponent.prototype.getChildContext = function () {
        return {
            arenaReducerDict: this.props.reduxInfo && this.props.reduxInfo.arenaReducerDict
        };
    };
    BundleComponent.prototype.buildLoadScenePromise = function (arenaReducerDict, sceneBundle, isInitial) {
        var _this = this;
        if (isInitial) {
            return new Promise(function (resolve) {
                return setImmediate(function () {
                    return _this.props.curtainLoadScene(_this.props.arenaReducerDict, _this.props.sceneBundle, true, resolve);
                });
            });
        }
        else {
            return new Promise(function (resolve) {
                return _this.props.curtainLoadScene(_this.props.arenaReducerDict, _this.props.sceneBundle, true, resolve);
            });
        }
    };
    BundleComponent.prototype.componentWillMount = function () {
        var loadedPromise = this.buildLoadScenePromise(this.props.arenaReducerDict, this.props.sceneBundle, true);
        this.setState({
            loadedPromise: loadedPromise
        });
    };
    BundleComponent.prototype.componentWillReceiveProps = function (nextProps) {
        var _this = this;
        var sceneBundle = nextProps.sceneBundle;
        if (sceneBundle !== this.props.sceneBundle) {
            this.state.loadedPromise.then(function () {
                var loadedPromise = _this.buildLoadScenePromise(nextProps.arenaReducerDict, nextProps.sceneBundle, false);
                _this.setState({
                    loadedPromise: loadedPromise
                });
            });
        }
    };
    BundleComponent.prototype.componentWillUnmount = function () {
        this.props.clearCurtain();
        this.props.mutableObj.isObsolete = true;
    };
    BundleComponent.prototype.render = function () {
        var _a = this.props, PlayingScene = _a.PlayingScene, sceneProps = _a.sceneProps;
        if (PlayingScene != null) {
            return React.createElement(PlayingScene, __assign({}, sceneProps));
        }
        else {
            return React.createElement("div", null);
        }
    };
    BundleComponent.childContextTypes = {
        arenaReducerDict: PropTypes.object
    };
    return BundleComponent;
}(React.Component));
export default BundleComponent;
