Object.defineProperty(exports, "__esModule", { value: true });
var redux_1 = require("redux");
var ActionTypes_1 = require("../ActionTypes");
var redux_saga_1 = require("redux-saga");
var reducers_1 = require("../reducers");
var createEnhancedStore_1 = require("./createEnhancedStore");
var sagas_1 = require("../sagas");
function createArenaStore(reducers, options) {
    if (reducers === void 0) { reducers = {}; }
    if (options === void 0) { options = {}; }
    var enhencers = options.enhencers, sagaOptions = options.sagaOptions, initialStates = options.initialStates, middlewares = options.middlewares;
    var sagaMiddleware = redux_saga_1.default(sagaOptions);
    var mergedMiddlewares = [sagaMiddleware];
    if (middlewares) {
        mergedMiddlewares = mergedMiddlewares.concat(middlewares);
    }
    var store = createEnhancedStore_1.default(Object.assign({
        arena: reducers_1.arenaReducer
    }, reducers), Object.assign({
        arena: reducers_1.getArenaInitState()
    }, initialStates || {}), enhencers
        ? redux_1.compose.apply(void 0, [redux_1.applyMiddleware.apply(void 0, mergedMiddlewares)].concat(enhencers)) : redux_1.applyMiddleware.apply(void 0, mergedMiddlewares));
    sagaMiddleware.run(sagas_1.default, { store: store });
    store.close = function () { return store.dispatch(redux_saga_1.END); };
    store.runSaga = function (saga) {
        return store.dispatch({
            type: ActionTypes_1.default.ARENA_INIT_AUDIENCE_SAGA,
            saga: saga
        });
    };
    return store;
}
exports.default = createArenaStore;
