Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Create redux-arena proxy store
 */
var redux_1 = require("redux");
function storeEnhancer(store, reducers) {
    var _currentReducers = reducers;
    var handler = {
        get: function (target, name) {
            if (name === "addSingleReducer") {
                return function (_a) {
                    var reducerKey = _a.reducerKey, reducer = _a.reducer;
                    var allStates = target.getState();
                    if (allStates.arena.stateTreeDict.get(reducerKey) != null)
                        return false;
                    _currentReducers = Object.assign({}, _currentReducers, (_b = {},
                        _b[reducerKey] = reducer,
                        _b));
                    target.replaceReducer(redux_1.combineReducers(_currentReducers));
                    return true;
                    var _b;
                };
            }
            if (name === "removeSingleReducer") {
                return function (reducerKey) {
                    if (reducerKey == null) {
                        throw new Error("Can not remove reducerKey of null.");
                    }
                    var newReducers = Object.assign({}, _currentReducers);
                    var allStates = target.getState();
                    delete newReducers[reducerKey];
                    _currentReducers = newReducers;
                    delete allStates[reducerKey];
                    target.replaceReducer(redux_1.combineReducers(newReducers));
                    return true;
                };
            }
            if (name === "replaceSingleReducer") {
                return function (_a) {
                    var reducerKey = _a.reducerKey, reducer = _a.reducer;
                    if (reducerKey == null)
                        throw new Error("reducerKey can not be null.");
                    var allStates = target.getState();
                    if (_currentReducers[reducerKey] == null)
                        throw new Error("reducer for key [" + reducerKey + "] doesn't exsit.");
                    _currentReducers = Object.assign({}, _currentReducers, (_b = {},
                        _b[reducerKey] = reducer,
                        _b));
                    target.replaceReducer(redux_1.combineReducers(_currentReducers));
                    return reducerKey;
                    var _b;
                };
            }
            return target[name];
        }
    };
    return new Proxy(store, handler);
}
function createEnhancedStore(reducers, initialState, enhencer) {
    var store = redux_1.createStore(redux_1.combineReducers(reducers), initialState, enhencer);
    return storeEnhancer(store, reducers);
}
exports.default = createEnhancedStore;
