Object.defineProperty(exports, "__esModule", { value: true });
function getRelativeLevel(name) {
    var result = name.match(/^\$(\d+)$/);
    return result && parseInt(result[1]);
}
function getLevelKey(rootState, reducerKey, levelNum) {
    if (levelNum === 0)
        return reducerKey;
    var _a = rootState.arena, stateTree = _a.stateTree, stateTreeDict = _a.stateTreeDict;
    var path = stateTreeDict.getIn([reducerKey, "path"]);
    return path.get(path.count() - 1 - 2 * levelNum);
}
function createPropsPicker(propsPicker, reduxInfo, mutableObj) {
    var arenaReducerDict = reduxInfo.arenaReducerDict;
    var sceneReducerKey = arenaReducerDict._arenaScene.reducerKey;
    var latestProps;
    var stateHandler = {
        get: function (target, name) {
            var levelNum = getRelativeLevel(name);
            if (levelNum != null) {
                name = getLevelKey(target.state, sceneReducerKey, levelNum);
            }
            var dictItem = arenaReducerDict[name];
            if (dictItem == null)
                return null;
            return target.state[dictItem.reducerKey];
        }
    };
    var actionsHandler = {
        get: function (target, name) {
            var levelNum = getRelativeLevel(name);
            if (levelNum != null) {
                name = getLevelKey(target.state, sceneReducerKey, levelNum);
            }
            var dictItem = arenaReducerDict[name];
            if (dictItem == null)
                return null;
            return dictItem.actions;
        }
    };
    var stateObj = { state: null };
    var stateDict = new Proxy(stateObj, stateHandler);
    var actionsDict = new Proxy(stateObj, actionsHandler);
    return function (state) {
        stateObj.state = state;
        if (mutableObj.isObsolete === true ||
            state.arena.propsLock !== false ||
            state.arena.stateTreeDict.getIn([sceneReducerKey, "isObsolete"]) === true) {
            return latestProps;
        }
        else {
            latestProps = propsPicker(stateDict, actionsDict);
            return latestProps;
        }
    };
}
exports.default = createPropsPicker;
