Object.defineProperty(exports, "__esModule", { value: true });
var ActionTypes_1 = require("../ActionTypes");
var getSceneInitState_1 = require("./getSceneInitState");
function sceneReducer(state, action) {
    if (state === void 0) { state = getSceneInitState_1.default(); }
    switch (action.type) {
        case ActionTypes_1.default.ARENA_SCENE_SET_STATE:
            return Object.assign({}, state, action.state);
        case ActionTypes_1.default.ARENA_SCENE_REPLACE_STATE:
            return Object.assign({}, action.state);
        default:
            return state;
    }
}
function createSceneReducer(extendSceneReducer, initState, sceneReducerKey) {
    return function (state, action) {
        if (state === void 0) { state = initState; }
        var isSceneAction = action._sceneReducerKey && action._sceneReducerKey === sceneReducerKey
            ? true
            : false;
        if (extendSceneReducer) {
            state = extendSceneReducer(state, action, isSceneAction);
        }
        return isSceneAction ? sceneReducer(state, action) : state;
    };
}
exports.default = createSceneReducer;
