/// <reference types="react" />
import * as React from "react";
import { ActionCreatorsMapObject } from "redux";
import { ArenaSceneExtraProps } from "../hocs";
import { Omit, ActionsProps, SceneBundleNo, DefaultActions, SceneBundleNoS, SceneBundleNoA, SceneBundleNoPP, SceneBundleNoAPP, SceneBundleNoSA, SceneBundleNoSPP, SceneBundleNoSAPP } from "./types";
declare function bundleToElement<P extends PP, S, A extends ActionCreatorsMapObject, PP>(bundle: SceneBundleNo<P, S, A, PP>, props?: JSX.IntrinsicAttributes & Omit<P, keyof PP>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof PP>>;
declare function bundleToElement<P extends PP, A extends ActionCreatorsMapObject, PP>(bundle: SceneBundleNoS<P, A, PP>, props?: JSX.IntrinsicAttributes & Omit<P, keyof PP>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof PP>>;
declare function bundleToElement<P extends PP, S, PP>(bundle: SceneBundleNoA<P, S, PP>, props?: JSX.IntrinsicAttributes & Omit<P, keyof PP>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof PP>>;
declare function bundleToElement<P extends S & ActionsProps<A>, S, A extends ActionCreatorsMapObject>(bundle: SceneBundleNoPP<P, S, A>, props?: JSX.IntrinsicAttributes & Omit<P, keyof (S & ActionsProps<A>)>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof (S & ActionsProps<A>)>>;
declare function bundleToElement<P extends PP, PP>(bundle: SceneBundleNoSA<P, PP>, props?: JSX.IntrinsicAttributes & Omit<P, keyof (PP)>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof (PP)>>;
declare function bundleToElement<P extends ActionsProps<A>, A extends ActionCreatorsMapObject>(bundle: SceneBundleNoSPP<P, A>, props?: JSX.IntrinsicAttributes & Omit<P, keyof (ActionsProps<A>)>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof (ActionsProps<A>)>>;
declare function bundleToElement<P extends S & ActionsProps<DefaultActions<S>>, S>(bundle: SceneBundleNoAPP<P, S>, props?: JSX.IntrinsicAttributes & Omit<P, keyof (S & ActionsProps<DefaultActions<S>>)>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof (ActionsProps<DefaultActions<{}>>)>>;
declare function bundleToElement<P extends ActionsProps<DefaultActions<{}>>>(bundle: SceneBundleNoSAPP<P>, props?: JSX.IntrinsicAttributes & Omit<P, keyof (ActionsProps<DefaultActions<{}>>)>, extraProps?: ArenaSceneExtraProps): React.ReactElement<JSX.IntrinsicAttributes & Omit<P, keyof (ActionsProps<DefaultActions<{}>>)>>;
export default bundleToElement;
